﻿using System;

namespace producerConsumer
{
    public class Duplicator
    {
        private readonly IBuffer _incoming;
        private readonly IBuffer _outgoing1, _outgoing2;

        public Duplicator(IBuffer incoming, IBuffer outgoing1, IBuffer outgoing2)
        {
            this._incoming = incoming;
            this._outgoing1 = outgoing1;
            this._outgoing2 = outgoing2;
        }

        public void Run()
        {
            while (true)
            {
                int element = _incoming.Take();
                Console.WriteLine("Duplicator consumed {0}", element);
                if (element == Producer.LastItem)
                {
                    break;
                }
                _outgoing1.Put(element);
                _outgoing2.Put(element);
            }
            _outgoing1.Put(Producer.LastItem);
            _outgoing2.Put(Producer.LastItem);
        }
    }
}
