﻿using System;

namespace producerConsumer
{
    public class MiddleMan
    {
        private readonly IBuffer _fromBuffer;
        private readonly IBuffer _toBuffer;

        public MiddleMan(IBuffer fromBuffer, IBuffer toBuffer)
        {
            this._fromBuffer = fromBuffer;
            this._toBuffer = toBuffer;
        }

        public void Run()
        {
            while (true)
            {
                int element = _fromBuffer.Take();
                _toBuffer.Put(element);
                Console.WriteLine("Middleman handled: {0}", element);
                if (element == Producer.LastItem)
                {
                    break;
                }
            }
        }

    }
}
