﻿using System;

namespace producerConsumer
{
    public class Consumer
    {
        private readonly IBuffer _buffer;

        /// <summary>
        /// Constructs a new object of the Consumer class
        /// </summary>
        /// <param name="buffer">the buffer to take from</param>
        public Consumer(IBuffer buffer)
        {
            _buffer = buffer;
        }

        public void Run()
        {
            while (true)
            {
                int element = _buffer.Take();
                Console.WriteLine("Consumer take: " + element);
                //Thread.Sleep(1);
                if (element == Producer.LastElement)
                {
                    break;
                }
            }

            //int element;
            //do
            //{
            //    element = _buffer.Take();
            //    Console.WriteLine("Consumer take: " + element);
            //} while (element != Producer.LastElement);
        }
    }
}
